// Library Author Erik Linder, SM0RVV
// Released 2011 under GNU GPLv3
// modified version by Klaus Hirschelmann, DJ7OO
//
// Usage: morse( <pin number>, <speed WPM>, <1=beep, 0=PTT> )
//        sendmsg( "<text-to-send>" )
// 
// port #13 is "H" during send sequence ( also activating on board LED )   
//
// mode select:  #9: open for "PTT"; ground for "BEEP"
// speed select: #3: ground for 12 WPM
//               #4: ground for 14 WPM
//               #5: ground for 16 WPM
//               #6: ground for 18 WPM
// Rem.: activated only after next program start or pushing "RESET"  

#include <Morse.h>

Morse morse(10, 16, 0);    // default parameters: data pin: #10; speed: 16w WPM; mode: PTT

/////////////////////////////////////////////
void setup()
{
 Serial.begin(9600);
 Serial.println("Open");
 pinMode( 13, OUTPUT );
 pinMode( 3, INPUT_PULLUP );
 pinMode( 4, INPUT_PULLUP );
 pinMode( 5, INPUT_PULLUP );
 pinMode( 6, INPUT_PULLUP );
 pinMode( 9, INPUT_PULLUP);

      if (digitalRead(3)==LOW&&digitalRead(9)==HIGH)  { Morse morse(10, 12, 0); } 
 else if (digitalRead(4)==LOW&&digitalRead(9)==HIGH)  { Morse morse(10, 14, 0); } 
 else if (digitalRead(5)==LOW&&digitalRead(9)==HIGH)  { Morse morse(10, 16, 0); } 
 else if (digitalRead(6)==LOW&&digitalRead(9)==HIGH)  { Morse morse(10, 18, 0); } 
 else if (digitalRead(3)==LOW&&digitalRead(9)==LOW)  { Morse morse(10, 12, 1); } 
 else if (digitalRead(4)==LOW&&digitalRead(9)==LOW)  { Morse morse(10, 14, 1); } 
 else if (digitalRead(5)==LOW&&digitalRead(9)==LOW)  { Morse morse(10, 16, 1); } 
 else if (digitalRead(6)==LOW&&digitalRead(9)==LOW)  { Morse morse(10, 18, 1); } 
}

/////////////////////////////////////////////
void loop()
{
  Serial.println("Running");
  digitalWrite(13, HIGH );
  delay(100);
  morse.sendmsg("CQ CQ CQ DE DJ7OO DJ7OO DJ7OO CQ CQ CQ DE DJ7OO DJ7OO DJ7OO CQ CQ CQ DE DJ7OO DJ7OO DJ7OO AR K");
  delay(100);
  digitalWrite(13, LOW );

// variable delay depending on #A0 analog value 
   int val,z,calc;
   val = analogRead(A0);                       // read analog value from poti ( 0 to 1023 )
   calc = map(val,0,1023,2,60);
   calc = 30;                                  // deactivate when NOT using fixvalue 30 secs. 
   Serial.println("Stop"); Serial.print("Delay: "); Serial.print(calc); Serial.println(" secs.");
   for(z=1; z<(calc); z++)  { delay(1000); }   // delay = 2-60 Secs. 
}


